From a8ad2a7d3983adc3b70708ac8d7778f2e53d3df3 Mon Sep 17 00:00:00 2001
From: bill-auger <mr.j.spam.me@gmail.com>
Date: Jul 14 2023 01:24:02 +0000
Subject: [PATCH 16/32] [gnustep-back][gnustep-gui]: upgrade to v0.30.0


---

diff --git a/pcr/gnustep-back/PKGBUILD b/pcr/gnustep-back/PKGBUILD
index b112d5d..7f32294 100644
--- a/pcr/gnustep-back/PKGBUILD
+++ b/pcr/gnustep-back/PKGBUILD
@@ -1,27 +1,30 @@
-# $Id: PKGBUILD 266875 2017-11-15 14:29:11Z foutrelis $
-# Maintainer (aur): Sergej Pupykin <pupykin.s+arch@gmail.com>
-# Maintainer (aur): Vesa Kaihlavirta <vegai@iki.fi>
+# Maintainer (aur): <mumei AT airmail DOT cc>
+# Contributor: Sergej Pupykin <pupykin.s+arch@gmail.com>
+# Contributor: Vesa Kaihlavirta <vegai@iki.fi>
 # Contributor: Sebastian Sareyko <public@nooms.de>
+# Maintainer: bill-auger <bill-auger@programmer.net>
+
+
+# build order: (gnustep-base) <- gnustep-gui <- gnustep-back <- gnustep-netclasses
 
-# parabola changes and rationale:
-#  no changes.
 
 pkgname=gnustep-back
-pkgver=0.26.2
+pkgver=0.30.0
 pkgrel=1
 pkgdesc="The GNUstep GUI Backend"
-arch=('x86_64' 'i686' 'armv7h')
-url="http://www.gnustep.org/"
+arch=(armv7h i686 x86_64)
+url=http://www.gnustep.org/
 license=('LGPL')
 depends=(libgl libxmu gcc-libs freetype2 cairo)
-makedepends=('gnustep-make' 'gnustep-base' 'gnustep-gui' 'libffi' 'gcc-objc')
-conflicts=('gnustep-back-svn')
+depends+=(libgnustep-gui.so)
+makedepends=('gnustep-make' 'gnustep-base' 'gnustep-gui>=0.30.0' 'libffi' 'gcc-objc')
+makedepends=( ${makedepends[*]/gnustep-base/} ) # this is a run-time dependency (also deps of gnustep-gui)
+makedepends=( ${makedepends[*]/gnustep-gui*/} ) # this is a run-time dependency
 groups=('gnustep-core')
-source=(https://github.com/gnustep/libs-back/releases/download/back-${pkgver//./_}/gnustep-back-$pkgver.tar.gz)
-#{,.sig}) # Upstream Signature wasn't correctly created
-sha256sums=('1807306b47f3cdb9f30743b5706d0e618621459ddf6347fad8c838867ed23322')
-#            'SKIP')
-#validpgpkeys=('83AAE47CE829A4146EF83420CA868D4C99149679')
+source=(https://github.com/gnustep/libs-back/releases/download/back-${pkgver//./_}/$pkgname-$pkgver.tar.gz{,.sig})
+sha256sums=('60177d44beebd0216be4aa7eea6cf009cf9ff844bc35f0eacd622bf710372cff'
+            'SKIP')
+validpgpkeys=('83AAE47CE829A4146EF83420CA868D4C99149679')
 
 build() {
   cd "$srcdir"/$pkgname-$pkgver
diff --git a/pcr/gnustep-gui/PKGBUILD b/pcr/gnustep-gui/PKGBUILD
index 3858287..500b407 100644
--- a/pcr/gnustep-gui/PKGBUILD
+++ b/pcr/gnustep-gui/PKGBUILD
@@ -1,31 +1,87 @@
-# $Id$
-# Maintainer (aur): Sergej Pupykin <pupykin.s+arch@gmail.com>
-# Maintainer (aur): Vesa Kaihlavirta <vegai@iki.fi>
+# Maintainer (aur): <mumei AT airmail DOT cc>
+# Contributor: Sergej Pupykin <pupykin.s+arch@gmail.com>
+# Contributor: Vesa Kaihlavirta <vegai@iki.fi>
 # Contributor: Sebastian Sareyko <public@nooms.de>
+# Maintainer: bill-auger <bill-auger@programmer.net>
+
+
+# build order: (gnustep-base) <- gnustep-gui <- gnustep-back <- gnustep-netclasses
 
-# parabola changes and rationale:
-#  no changes.
 
 pkgname=gnustep-gui
-pkgver=0.26.2
+pkgver=0.30.0
 pkgrel=1
 pkgdesc="The GNUstep GUI class library"
-arch=('x86_64' 'i686' 'armv7h')
-url="http://www.gnustep.org/"
+arch=(armv7h i686 x86_64)
+url=http://www.gnustep.org/
 license=('LGPL')
-depends=('aspell' 'gcc-libs' 'libcups' 'audiofile' 'libsndfile' 'giflib' 'libao')
-makedepends=('gcc-objc' 'gnustep-base' 'gnustep-make')
-conflicts=('gnustep-gui-svn')
+depends=(
+  'gcc-libs'
+  'libjpeg'
+  'libpng'
+  'libtiff'
+)
+makedepends=(
+  'gcc-objc'
+  'gnustep-base'
+  'gnustep-make'
+)
+makedepends=( ${makedepends[*]/gnustep-base/} ) # this is a run-time dependency
+optdepends=(
+  'aspell'
+  'audiofile'
+  'flite1: required for speech synthesis'
+  'giflib'
+  'libao'
+  'libcups'
+  'libsndfile'
+)
+provides=('libgnustep-gui.so')
 groups=('gnustep-core')
 options=('!makeflags')
-source=(https://github.com/gnustep/libs-gui/releases/download/gui-${pkgver//./_}/gnustep-gui-${pkgver}.tar.gz)
-#{,.sig}) # Upstream Signature wasn't correctly created
-sha256sums=('09ab2ac10f4bf98f1254c6c525c752d1f7b13bf0e6cd95530452c504fae7b4db')
-#            'SKIP')
-#validpgpkeys=('83AAE47CE829A4146EF83420CA868D4C99149679')
+source=(https://github.com/gnustep/libs-gui/releases/download/gui-${pkgver//./_}/$pkgname-$pkgver.tar.gz{,.sig})
+sha256sums=('469dcaa54ed05b2520a704c30c0761a75b3ade8428e2e64645fb7b38a15c3cc3'
+            'SKIP')
+validpgpkeys=('83AAE47CE829A4146EF83420CA868D4C99149679')
 
-prepare() {
-  cd "$srcdir"/$pkgname-$pkgver
+
+_version_constraint() # (dep_pkgname [precision])
+{
+  Log() { [[ "${FUNCNAME[2]}" == package ]] && echo "$@" >&2 || : ; }
+
+
+  local dep_pkgname=$1
+  declare -i req_precision=$2
+  local full_version=$(pacman -S --print-format='%v' ${dep_pkgname} | tail -n 1)
+  local n_dots=$(tmp=${full_version%-*} ; tmp=${tmp//[^\.]} ; echo "${#tmp}" ;)
+  local def_precision=$(( n_dots + 1 ))
+  local is_prec_valid=$(( req_precision > 0 && req_precision <= def_precision ))
+  local precision=$( (( is_prec_valid )) && echo ${req_precision} || echo ${def_precision} )
+  local pkgver_rx='[^-\.\ ]+'
+  local subver_rx='\.'${pkgver_rx}
+  local pkgrel_rx='[^-\ ]+'
+  local capture_rx=${pkgver_rx}
+  for (( n_dots=1 ; n_dots < precision ; ++n_dots )) ; do capture_rx+=${subver_rx} ; done ;
+  local version pkgrel subver_inc pkgrel_inc version_min version_max constraint_string
+
+  if   [[ "${full_version}" =~ ^(${capture_rx})(${subver_rx})*-(${pkgrel_rx})$ ]]
+  then version=${BASH_REMATCH[1]}
+       pkgrel=${BASH_REMATCH[3]%%.*}
+       subver_inc=$(( ${version##*.} + 1 ))
+       pkgrel_inc=$(( pkgrel + 1 ))
+       version_min=$(   (( ! is_prec_valid    )) && echo ${full_version%-*}-${pkgrel} || \
+                                                    echo ${version}                      )
+       version_max=$( ( (( ! is_prec_valid    )) && echo ${full_version%-*}-${pkgrel_inc} ) || \
+                      ( [[ "${version}" =~ \. ]] && echo ${version%.*}.${subver_inc}      ) || \
+                                                    echo ${subver_inc}                         )
+       constraint_string="${dep_pkgname}>=${version_min} ${dep_pkgname}<${version_max}"
+
+       Log "Applied version constraint: '${constraint_string}'"
+  else Log "ERROR: in _version_constraint() parsing: dep_pkgname='${dep_pkgname}' full_version='${full_version}'"
+       exit 1
+  fi
+
+  echo -n "${constraint_string}"
 }
 
 build() {
@@ -36,6 +92,8 @@ build() {
 }
 
 package() {
+  depends+=( $(_version_constraint gnustep-base 2) )
+
   cd "$srcdir"/$pkgname-$pkgver
   make DESTDIR="$pkgdir" install
 }

